from collections import deque, defaultdict
 
def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()

    if not data or len(data[0].split()) != 3:
        print("Некорректный ввод. Ожидается три числа на первой строке.")
        return
   
    n, m, k = map(int, data[0].split())

    from collections import deque, defaultdict
    
    # Создаем граф в виде списка смежности
    graph = defaultdict(list)
    
    # Считываем дороги
    for i in range(1, m + 1):
        a, b = map(int, data[i].split())
        graph[a].append(b)
        graph[b].append(a)
    
    # Считываем охранников
    guards = []
    for i in range(m + 1, m + k + 1):
        p, h = map(int, data[i].split())
        guards.append((p, h))
    
    protected = set()  # Для хранения охраняемых складов

    # Обрабатываем каждого охранника
    for start, endurance in guards:
        # BFS
        queue = deque([(start, 0)])  # (номер склада, текущая длина пути)
        visited = set()  # Охваченные склады для текущего охранника
        
        while queue:
            node, distance = queue.popleft()
            
            if node in visited:
                continue
            
            visited.add(node)
            protected.add(node)  # Добавляем текущий склад в охраняемые
            
            # Если расстояние достигает предела выносливости, выходим
            if distance < endurance:
                for neighbor in graph[node]:
                    if neighbor not in visited:
                        queue.append((neighbor, distance + 1))
    
    # Результаты
    protected = sorted(protected)  # Сортируем номера охраняемых складов
    print(len(protected))
    if protected:
        print(' '.join(map(str, protected)))
    else:
        print()

if __name__ == "__main__":
    main()