from collections import deque, defaultdict

def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
   
    # Считываем основные параметры
    n, m, k = map(int, data[0].split())

    # Создаем граф в виде списка смежности
    graph = defaultdict(list)
    for i in range(1, m + 1):
        a, b = map(int, data[i].split())
        graph[a].append(b)
        graph[b].append(a)
   
    # Считываем охранников
    guards = []
    for i in range(m + 1, m + k + 1):
        p, h = map(int, data[i].split())
        guards.append((p, h))

    # Используем множество для хранения всех охраняемых складов
    protected = set()

    # Функция BFS для поиска охраняемых складов
    def bfs(start, endurance):
        queue = deque([(start, 0)])  # Очередь с текущей позицией и длиной пути
        visited = set()  # Локальное множество для текущего охранника

        while queue:
            node, distance = queue.popleft()

            if node in visited:
                continue

            visited.add(node)
            protected.add(node)  # Добавляем текущий склад в охраняемые

            # Если выносливость позволяет, продолжаем обход
            if distance < endurance:
                for neighbor in graph[node]:
                    if neighbor not in visited:
                        queue.append((neighbor, distance + 1))

    # Запускаем BFS для каждого охранника
    for start, endurance in guards:
        bfs(start, endurance)

    # Выводим результаты
    protected = sorted(protected)
    print(len(protected))
    if protected:
        print(' '.join(map(str, protected)))

if __name__ == "__main__":
    main()